%^^A ---- introduction
\section{Introduction}

This package provides means for manual change markup.

Any comments, thoughts or improvements are welcome.
The package is maintained at \emph{gitlab}, please see

\url{http://edgesoft.de/projects/latex/changes/}

for links to source code access, bug and feature tracker, etc.
If you want to contact me directly, please send an email to \href{mailto:ekleinod@edgesoft.de}{ekleinod@edgesoft.de}.
Please start your email subject with \texttt{[changes]}.

\begin{quote}
	The changes-package allows the user to manually markup changes of text, such as additions, deletions, or replacements.
	Changed text is shown in a different color; deleted text is striked out.
	Additionally, text can be highlighted and/or commented.
	The package allows free definition of additional authors and their associated color.
	It also allows you to change the markup of changes, authors, highlights or comments.
\end{quote}

Here is a short example of change markup:

\begin{quote}
	This is \added[id=EK, comment={missing word}]{new} text.
	In this sentence, I replace a \replaced[id=EK]{good}{bad} word.
	And, to sum up the text changes, there is another \deleted[id=EK]{obsolete} word to delete.
	Furthermore, text can be \highlight[id=EK]{highlighted} or just \comment[id=EK]{For the fun of it.}commented.
\end{quote}

Parallel to this manual is a folder ``examples'' which contains an extensive collection of example files, both \hologo{LaTeX} and PDF files.
Please refer to these examples for inspiration and first problem solving.


%^^A ---- usage
\cleardoublepage
\section{Using the \chpackage{changes}-package}
\label{sec:usage}

In this section a typical use case of the \chpackage{changes}-package is described.
You can find the detailed description of the package options and new commands in \autoref{sec:ui}.

We start with the text you want to change.
You want to markup the changes for each author individually.
Such a change markup is well-known in WYSIWYG text processors such as \emph{LibreOffice}, \emph{OpenOffice}, or \emph{Word}.

The \chpackage{changes}-package was developed in order to support such change markup.
The package provides commands for defining authors, and for marking text as added, deleted, or replaced.
Additionally, text can be highlighted or commented.
In order to use the package, you should follow these steps:

\begin{enumerate}
	\item use \chpackage{changes}-package
	\item define authors
	\item markup text changes
	\item highlight and comment text
	\item typeset the document with \hologo{LaTeX}
	\item output list of changes
	\item remove markup
\end{enumerate}


\minisec{Use \chpackage{changes}-package}

In order to activate change management, use the \chpackage{changes}-package as follows:

\chinline{usepackage_changes}

respectively

\chinline{usepackage_options_changes}

You can use the options for defining the layout of the change markup.
You can change the layout after using the \chpackage{changes}-package as well.

For detailed information please refer to \autoref{sec:ui:options} and \autoref{sec:ui:customizingoutput}.


\minisec{Define authors}

The \chpackage{changes}-package provides a default anonymous author.
If you want to track your changes depending on the author, you have to define the needed authors as follows:

\chinline{definechangesauthor}

Every author is uniquely identified through his or her id.
You can give every author an optional name and/or color.

For detailed information please refer to \autoref{sec:ui:authormanagement}.


\minisec{Markup text changes}

Now everything is set to markup the changed text.
Please use the following commands according to your change:

for added text:

\chinline{added}

for deleted text:

\chinline{deleted}

for replaced text:

\chinline{replaced}

Stating the author's id and/or a comment is optional.

For detailed information please refer to \autoref{sec:ui:changemanagement}.


\minisec{Highlight and comment text}

Maybe you want to highlight orcomment some text?

highlight text:

\chinline{highlight}

comment text:

\chinline{comment}

Stating the author's id and/or a comment for highlights is optional.

For detailed information please refer to \autoref{sec:ui:comment}.


\minisec{Typeset the document with \hologo{LaTeX}}

After marking your changes in the text you are able to display them in the generated document by processing it as usual with \hologo{LaTeX}.
By processing your document the changed text is layouted as you stated by the corresponding options and/or special commands.

\minisec{Output list of changes}

You can print a list of changes using:

\chinline{listofchanges}

The list is meant to be the analogon to the list of tables, or the list of figures.

Stating the style is optional, default is \choption{style=list}.
In order to print a quick overview of the number and kind of changes of every author, use the option \choption{style=summary} or  \choption{style=compactsummary}.
Show only specific changes by using the \choption{show} option.

By running \hologo{LaTeX} the data of the list is written into an auxiliary file.
This data is used in the next \hologo{LaTeX} run for typesetting the list of changes.
Therefore, two \hologo{LaTeX} runs are needed after every change in order to typeset an up-to-date list of changes.

For detailed information please refer to \autoref{sec:ui:overview}.


\minisec{Remove markup}

Often you want to remove the change markup after acknowledging or rejecting the changes.
You can suppress the output of changes with:

\chinline{usepackage_final_changes}

In order to remove the markup from the \hologo{LaTeX} files, you have to remove the commands by hand or use the script by Yvon Cui.
You find the script in the directory:

\chinline[, language=bash]{path_script}

The script removes all markups either keeping or rejecting the change.
You can select or deselect markup from removal using the interactive mode by starting the script without options.

The script requires \emph{python3}.

Use the script as follows:

\chinputlisting{, language=bash}{userdoc/script_pymergechanges}

Run the script with no options and files for a short help text:

\chinputlisting{, language=bash}{userdoc/script_pymergechanges_empty}

Known issues:

\begin{itemize}
	\item removes only markup that is used in one line, not markup that spans multiple lines
	\item problems with nested commands
\end{itemize}





%^^A ---- limitations
\cleardoublepage
\section{Limitations and possible enhancements}
\label{sec:limitations}

The \chpackage{changes}-package was carefully programmed and tested.
Yet the possibility of errors in the package exists, you might encounter problem during use, or you might miss functionality.
In that case, please go to

\url{http://changes.sourceforge.net/}

There you find information on how to report errors or improvements, give advice to other users, or participate in the development of the package.

You can write me an email too, please send it to \href{mailto:ekleinod@edgesoft.de}{ekleinod@edgesoft.de}.
In that case, please start your email subject with \texttt{[changes]}.

Change markup of texts works well, it is possible to markup whole paragraphs.
You cannot markup:

\begin{itemize}
	\item figures
	\item tables
	\item headings
	\item some commands
	\item several paragraphs (sometimes)
\end{itemize}

You can try putting such text in an extra file and include in with \texttt{input}.
This works sometimes, give it a try.
Kudos to Charly Arenz for this tip.

There is a problem of typesetting footnotes or margin notes in special environments, such as tables or tabbings.
Avoid such markup when using these environments.

There are several possibilities of enhancing the \chpackage{changes}-package.
I will describe but a few here, I will not implement them due to lack of time and/or skill.
You can have a look at the complete list of enhancements in the issue tracker of \emph{gitlab}.

\begin{itemize}
	\item selecting of acknowledged and rejected texts; deletion of the corresponding markup
	\item markup of more than one paragraph
	\item markup of figures and tables
	\item automatic markup based on diff information (with regard to the limitations, such as markup of paragraphs, figures etc.)
	\item translation of language dependent texts and the user documentation in other languages
\end{itemize}


%^^A ---- user interface
\cleardoublepage
\section{User interface of the \chpackage{changes}-package}
\label{sec:ui}

This section describes the user interface of the \chpackage{changes}-package, i.e.\ all options and commands of the package.
Every option and new command is described.
If you want to see the options and commands in action, please refer to the examples in

\chinline[, language=bash]{path_doc_examples}

The example files are named with the used option respectively command.

%^^A -- options
\subsection{Package Options}
\label{sec:ui:options}

\chinline{usepackage_options_changes}

The package options control the behavior of the overall package, i.\,e.\ all markup commands.

The following options are defined:

\localtableofcontents



\subsubsection{draft}

\chinline{usepackage_draft_changes}

The \choption{draft}-option enables markup of changes.
The list of changes is available via \chcommand{listofchanges}.
This option is the default option, if no other option is selected.

The \chpackage{changes} package reuses the declaration of \choption{draft} in \chcommand{documentclass}.
The local declaration of \choption{final} overrules the declaration of \choption{draft} in \chcommand{documentclass}.

\subsubsection{final}

\chinline{usepackage_final_changes}

The \choption{final}-option disables markup of changes, only the correct text will be shown.
The list of changes is disabled, too.

The \chpackage{changes} package reuses the declaration of \choption{final} in \chcommand{documentclass}.
The local declaration of \choption{draft} overrules the declaration of \choption{final} in \chcommand{documentclass}.


\subsubsection{markup}

\chinline{usepackage_markup_changes}

The \choption{markup} option chooses a predefined visual markup of changed text.
The default markup is chosen if no explicit markup is given.
The markup chosen with \choption{markup} can be overwritten with the more special markup options \choption{addedmarkup}, \choption{deletedmarkup}, \choption{commentmarkup}, or \choption{highlightmarkup}.

The following values for \emph{markup} are defined:

\begin{description}
	\item [\choption{default}] default markup for added and deleted text, comments and highlighted text (default markup)
	\item [\choption{underlined}] underlined for added text, wavy underlined for highlighted text, default for deleted text, and comments
	\item [\choption{bfit}] bold added text, italic deleted text, default for comments and highlighted text
	\item [\choption{nocolor}] no colored markup, underlined for added text, wavy underlined for highlighted text, default for deleted text and comments
\end{description}

\chexample{usepackage_markup_changes}

When changing from color markup to markup without color and vice versa, some errors occur if an auxiliary file exists.
Please ignore the errors, they vanish in the second run.

\subsubsection{addedmarkup}

\chinline{usepackage_addedmarkup_changes}

The \choption{addedmarkup} option chooses a predefined visual markup of added text.
The default markup is chosen if no explicit markup is given.
The option \choption{addedmarkup} overwrites the markup chosen with \choption{markup}.

The following values for \emph{addedmarkup} are defined:

\begin{description}
	\item [\choption{colored}] no text markup, just coloring -- {\color{orange} example} (default)
	\item [\choption{uline}] underlined text -- \uline{example}
	\item [\choption{uuline}] double underlined text -- \uuline{example}
	\item [\choption{uwave}] wavy underlined text -- \uwave{example}
	\item [\choption{dashuline}] dashed underlined text -- \dashuline{example}
	\item [\choption{dotuline}] dotted underlined text -- \dotuline{example}
	\item [\choption{bf}] bold text -- \textbf{example}
	\item [\choption{it}] italic text -- \textit{example}
	\item [\choption{sl}] slanted text -- \textsl{example}
	\item [\choption{em}] emphasized text -- \emph{example}
\end{description}

The output of replaced text is a combination of added and deleted text, thus any change in their layout influences the layout of replaced text.

\chexample{usepackage_addedmarkup_changes}


\subsubsection{deletedmarkup}

\chinline{usepackage_deletedmarkup_changes}

The \choption{deletedmarkup} option chooses a predefined visual markup of deleted texty.
The default markup is chosen if no explicit markup is given.
The option \choption{deletedmarkup} overwrites the markup chosen with \choption{markup}.

The following values for \emph{deletedmarkup} are defined:

\begin{description}
	\item [\choption{sout}] striked out text -- \sout{example} (default)
	\item [\choption{xout}] crossed out text -- \xout{example}
	\item [\choption{colored}] no text markup, just coloring -- {\color{orange} example}
	\item [\choption{uline}] underlined text -- \uline{example}
	\item [\choption{uuline}] double underlined text -- \uuline{example}
	\item [\choption{uwave}] wavy underlined text -- \uwave{example}
	\item [\choption{dashuline}] dashed underlined text -- \dashuline{example}
	\item [\choption{dotuline}] dotted underlined text -- \dotuline{example}
	\item [\choption{bf}] bold text -- \textbf{example}
	\item [\choption{it}] italic text -- \textit{example}
	\item [\choption{sl}] slanted text -- \textsl{example}
	\item [\choption{em}] emphasized text -- \emph{example}
\end{description}

The output of replaced text is a combination of added and deleted text, thus any change in their layout influences the layout of replaced text.

\chexample{usepackage_deletedmarkup_changes}


\subsubsection{highlightmarkup}

\chinline{usepackage_highlightmarkup_changes}

The \choption{highlightmarkup} option chooses a predefined visual markup for highlighted text.
The default markup is chosen if no explicit markup is given.
The option \choption{highlightmarkup} overwrites the markup chosen with \choption{markup}.

The following values for \emph{highlightmarkup} are defined:

\begin{description}
	\item [\choption{background}] markup by background color -- \colorbox{orange!30}{example} (default)
	\item [\choption{uuline}] double underlined text -- \uuline{example}
	\item [\choption{uwave}] wavy underlined text -- \uwave{example}
\end{description}

\chexample{usepackage_highlightmarkup_changes}



\subsubsection{commentmarkup}

\chinline{usepackage_commentmarkup_changes}

The \choption{commentmarkup} option chooses a predefined visual markup for comments.
The default markup is chosen if no explicit markup is given.
The option \choption{commentmarkup} overwrites the markup chosen with \choption{markup}.

The following values for \emph{commentmarkup} are defined:

\begin{description}
	\item [\choption{todo}] comment as todo note, which is not added to list of todos \todo{example comment}(default)
	\item [\choption{margin}] comment in margin\marginpar{example comment}
	\item [\choption{footnote}] comment as footnote\footnote{example comment}
	\item [\choption{uwave}] wavy underlined text -- \uwave{example comment}
\end{description}

\chexample{usepackage_commentmarkup_changes}


\subsubsection{authormarkup}

\chinline{usepackage_authormarkup_changes}

The \choption{authormarkup} option chooses a predefined visual markup of the author's identification.
The default markup is chosen if no explicit markup is given.

The following values for \emph{authormarkup} are defined:

\begin{description}
	\item [\choption{superscript}] superscripted text -- text\textsuperscript{author} (default)
	\item [\choption{subscript}] subscripted text -- text\textsubscript{author}
	\item [\choption{brackets}] text in brackets -- text(author)
	\item [\choption{footnote}] text in footnote -- text\footnote{author}
	\item [\choption{none}] no author identification
\end{description}

\chexample{usepackage_authormarkup_changes}


\subsubsection{authormarkupposition}

\chinline{usepackage_authormarkupposition_changes}

The \choption{authormarkupposition} option chooses the position of the author's identification.
The default value is chosen if no explicit markup is given.

The following values for \emph{authormarkupposition} are defined:

\begin{description}
	\item [\choption{right}] right of the text -- text\textsuperscript{author} (default)
	\item [\choption{left}] left of the text -- \textsuperscript{author}text
\end{description}

\chexample{usepackage_authormarkupposition_changes}



\subsubsection{authormarkuptext}

\chinline{usepackage_authormarkuptext_changes}

The \choption{authormarkuptext} option chooses the text that is used for the author's identification.
The default value is chosen if no explicit markup is given.

The following values for \emph{authormarkuptext} are defined:

\begin{description}
	\item [\choption{id}] author's id -- text\textsuperscript{id} (default)
	\item [\choption{name}] author's name -- text\textsuperscript{authorname}
\end{description}

\chexample{usepackage_authormarkuptext_changes}


\subsubsection{todonotes}

\chinline{usepackage_todonotes_changes}

Options for the \chpackage{todonotes} package can be specified as parameters of the \choption{todonotes}-option.
Several options or options with special characters have to be put in curly brackets.

\chexample{usepackage_todonotes_changes}



\subsubsection{truncate}

\chinline{usepackage_truncate_changes}

Options for the \chpackage{truncate} package can be specified as parameters of the \choption{truncate}-option.
Several options or options with special characters have to be put in curly brackets.

\chexample{usepackage_truncate_changes}


\subsubsection{ulem}

\chinline{usepackage_ulem_changes}

Options for the \chpackage{ulem} package can be specified as parameters of the \choption{ulem}-option.
Several options or options with special characters have to be put in curly brackets.

\chexample{usepackage_ulem_changes}


\subsubsection{xcolor}

\chinline{usepackage_xcolor_changes}

Options for the \chpackage{xcolor} package can be specified as parameters of the \choption{xcolor}-option.
Several options or options with special characters have to be put in curly brackets.

\chexample{usepackage_xcolor_changes}



%^^A -- Change management ----------------------------------------------------------
\subsection{Change management}
\label{sec:ui:changemanagement}

\localtableofcontents

\chnewcmd{added}

\chinline{added}

The command \chcommand{added} marks newly added text.
The new text is given in curly braces.

The optional argument contains key-value-pairs for author-id and comment.
The author-id has to be defined using \chcommand{definechangesauthor}.
If the comment contains special characters or spaces, use curly brackets to enclose the comment.

If a comment is given, the direct author markup at the changes text is omitted, because the author is printed in the comment.

\chexample{added}
\chresult{added}


\chnewcmd{deleted}

\chinline{deleted}

The command \chcommand{deleted} marks deleted text.
The deleted text is given in curly braces.

For the optional arguments see \chcommand{added} (\autoref{sec:ui:cmd:added}).

\chexample{deleted}
\chresult{deleted}



\chnewcmd{replaced}

\chinline{replaced}

The command \chcommand{replaced} marks replaced text.
The new and the replaced text are given in this order in curly braces.

For the optional arguments see \chcommand{added} (\autoref{sec:ui:cmd:added}).

The output of replaced text is a combination of added and deleted text, thus any change in their layout influences the layout of replaced text.

\chexample{replaced}
\chresult{replaced}



%^^A -- Highlighting and Comments ------------------------------------------------------
\subsection{Highlighting and Comments}
\label{sec:ui:comment}

\localtableofcontents

\chnewcmd{highlight}

\chinline{highlight}

The command \chcommand{highlight} highlights text.
The highlighted text is given in curly braces.

For the optional arguments see \chcommand{added} (\autoref{sec:ui:cmd:added}).

\chexample{highlight}
\chresult{highlight}


\chnewcmd{comment}

\chinline{comment}

The command \chcommand{comments} adds a comment to the document.
The comment is given in curly braces.

The command has only one optional argument: a key-value-pair for the author-id.
The author-id has to be defined using \chcommand{definechangesauthor}.

The comments are numbered automatically, the number is printed in the comment.

\chexample{comment}
\chresult{comment}




%^^A -- Overview of changes
\subsection{Overview of changes}
\label{sec:ui:overview}


\chnewcmd{listofchanges}

\chinline{listofchanges}

The command \chcommand{listofchanges} outputs a list or summary of changes.
The first \hologo{LaTeX}-run creates an auxiliary file, the second run uses the data of this file.
Therefore you need two \hologo{LaTeX}-runs for an up-to-date list of changes.

There are three optional arguments:

\begin{description}
	\item[\choption{style}] list style
	\item[\choption{title}] individual title
	\item[\choption{show}] markup types
\end{description}

\paragraph{style}
The \choption{style} argument defines the layout of the list of changes.
Three styles are defined:

\begin{description}
	\item[\choption{list}] prints the list of changes like a list of figures (default)
	\item[\choption{summary}] prints the number of changes grouped by author
	\item[\choption{compactsummary}] same as \choption{summary} but entries with count 0 are omitted
\end{description}

\paragraph{title}
The \choption{title} argument is used to change the title for the list.
If you want to use special characters or spaces in the title, enclose it in curly braces.

\paragraph{show}
The \choption{show} argument defines which types of change markup are shown in the list of changes.
You can combine the values using the \texttt{|} character.
For example if you want to show all additions and deletions, use \texttt{show=added|deleted}.

The following values are defined:

\begin{description}
	\item[\choption{all}] show all types (default)
	\item[\choption{added}] show only additions
	\item[\choption{deleted}] show only deletions
	\item[\choption{replaced}] show only replacements
	\item[\choption{highlight}] show only highlights
	\item[\choption{comment}] show only comments
\end{description}

\chexample{listofchanges}



%^^A -- Author management -----------------------------------------------------
\subsection{Author management}
\label{sec:ui:authormanagement}

\chnewcmd{definechangesauthor}

\chinline{definechangesauthor}

The command \chcommand{definechangesauthor} defines a new author for changes.
You have to define a unique author's id, special characters or spaces are not allowed within the author's id.

You may define a corresponding color and the author's name.
If you do not define a color, blue is used.

The author's name is used in the list of changes and in the markup if you set the corresponding option.

The package predefines one anonymous author without id.

\chexample{definechangesauthor}


%^^A -- Adaptation of the output -----------------------------------------------------
\subsection{Adaptation of the output}
\label{sec:ui:customizingoutput}

\localtableofcontents

\chnewcmd{setaddedmarkup}

\chinline{setaddedmarkup}

The command \chcommand{setaddedmarkup} defines the layout of added text.
The default markup is colored text, or the markup set with the option \choption{markup} respectively \choption{addedmarkup}.

Values for definition:

\begin{itemize}
	\item any \hologo{LaTeX}-commands
	\item added text can be used with ``\#1''
\end{itemize}

The output of replaced text is a combination of added and deleted text, thus any change in their layout influences the layout of replaced text.

\chexample{setaddedmarkup}


\chnewcmd{setdeletedmarkup}

\chinline{setdeletedmarkup}

The command \chcommand{setdeletedmarkup} defines the layout of deleted text.
The default markup is striked-out, or the markup set with the option \choption{markup} respectively \choption{deletedmarkup}.

Values for definition:

\begin{itemize}
	\item any \hologo{LaTeX}-commands
	\item deleted text can be used with ``\#1''
\end{itemize}

The output of replaced text is a combination of added and deleted text, thus any change in their layout influences the layout of replaced text.

\chexample{setdeletedmarkup}


\chnewcmd{sethighlightmarkup}

\chinline{sethighlightmarkup}

The command \chcommand{sethighlightmarkup} defines the layout of highlighted text.
The default markup is via a background color, or the markup set with the option \choption{markup} respectively \choption{highlightmarkup}.

Values for definition:

\begin{itemize}
	\item any \hologo{LaTeX}-commands
	\item highlighted text can be used with ``\#1''
	\item \chpackage{ifthenelse} boolean test for colored text ``\chcommand{isColored}''
	\item author's color can be used with color ``authorcolor''
\end{itemize}

\chexample{sethighlightmarkup}


\chnewcmd{setcommentmarkup}

\chinline{setcommentmarkup}

The command \chcommand{setcommentmarkup} defines the layout of comments.
The default markup is a margin note, or the markup set with the option \choption{markup} respectively \choption{commentmarkup}.

Values for definition:

\begin{itemize}
	\item any \hologo{LaTeX}-commands
	\item comment can be used with ``\#1''
	\item author's id can be used with ``\#2''
	\item author output (id or name) can be used with ``\#3''
	\item \chpackage{ifthenelse} boolean test for anonymous author ``\chcommand{isAnonymous}''
	\item \chpackage{ifthenelse} boolean test for colored text ``\chcommand{isColored}''
	\item author's color can be used with color ``authorcolor''
	\item comment count of the autor can be used with counter ``authorcommentcount''
\end{itemize}

\chexample{setcommentmarkup}


\chnewcmd{setauthormarkup}

\chinline{setauthormarkup}

The command \chcommand{setauthormarkup} defines the layout of the author's markup in the text.
The default markup is a superscripted author's text.

Values for definition:

\begin{itemize}
	\item any \hologo{LaTeX}-commands
	\item author output (id or name) can be used with ``\#1''
\end{itemize}

\chexample{setauthormarkup}


\chnewcmd{setauthormarkupposition}

\chinline{setauthormarkupposition}

The command \chcommand{setauthormarkupposition} defines the position of the author's markup relative to the changed text.
The default position is right of the changed text.

The following values for \emph{authormarkupposition} are defined:

\begin{description}
	\item [\choption{right}] right of the text -- text\textsuperscript{author} (default)
	\item [\choption{left}] left of the text -- \textsuperscript{author}text
\end{description}

\chexample{setauthormarkupposition}


\chnewcmd{setauthormarkuptext}

\chinline{setauthormarkuptext}

The command \chcommand{setauthormarkuptext} defines the text for the author's markup.
The default markup is the author's id.

The following values for \emph{authormarkuptext} are defined:

\begin{description}
	\item [\choption{id}] author's id -- text\textsuperscript{id} (default)
	\item [\choption{name}] author's name -- text\textsuperscript{authorname}
\end{description}

\chexample{setauthormarkuptext}



\chnewcmd{settruncatewidth}

\chinline{settruncatewidth}

The command \chcommand{settruncatewidth} sets the width of the truncation in the list of changes to the given width.
The default width is \texttt{0.6}\chcommand{textwidth}.

\chexample{settruncatewidth}



\chnewcmd{setsummarywidth}

\chinline{setsummarywidth}

The command \chcommand{setsummarywidth} sets the width of the list of changes in summary style to the given width.
The default width is \texttt{0.3}\chcommand{textwidth}.

\chexample{setsummarywidth}



\chnewcmd{setsummarytowidth}

\chinline{setsummarytowidth}

The command \chcommand{setsummarytowidth} sets the width of the list of changes in summary style to the width of the given text.

\chexample{setsummarytowidth}



\chnewcmd{setsocextension}

\chinline{setsocextension}

The command \chcommand{setsocextension} sets the extension of the auxiliary file for the summary of changes (soc-file\footnote{%
	``soc'' stands for ``summary of changes''.
}).
The default extension is ``\texttt{soc}''.

In the example, the soc-file for ``\texttt{foo.tex}'' would be named ``\texttt{foo.changes}'' resp.\ ``\texttt{foo.chg}'' instead of the default name ``\texttt{foo.soc}''.

\chexample{setsocextension}

\chimportant{Do not use a \hologo{LaTeX} standard file extension, such as ``toc'' or ``loc'', as this would collide with the normal \hologo{LaTeX} run.}



%^^A -- packages
\subsection{Used packages}
\label{sec:ui:packages}

The \chpackage{changes}-package uses already existing packages for it's functions.
You will find detailed description of the packages in their distributions.

The following packages are always required and have to be installed for the \chpackage{changes}-package:
\begin{description}
	\item [xifthen] provides an enhanced \chcommand{if}-command as well as a \texttt{while}-loop
	\item [xkeyval] provides options with key-value-pairs
	\item [xstring] improves string operations
\end{description}

The following packages are sometimes required and have to be installed if used by the corresponding option:
\begin{description}
	\item [pdfcolmk] loaded if colored text is used for markup (default markup); solves the problem of colored text and page breaks (with pdflatex)
	\item [todonotes] loaded if comments are layouted as todo notes (default markup)
	\item [ulem] loaded if text has to be striked or exed out (default markup)
	\item [xcolor] loaded if colored text is used for markup (default markup)
\end{description}


%^^A -- Authors -------------------------------------------------------------
\cleardoublepage
\section{Authors}
\label{sec:authors}

Several authors contributed to the \chpackage{changes}-package.
Many bugs and problems were solved or their solution inspired via de.comp.text.tex.
Thanks.

The authors are (in alphabetical order):
\begin{itemize}
	\item Chiaradonna, Silvano
	\item Cui, Yvon
	\item Fischer, Ulrike
	\item Giovannini, Daniele
	\item Kleinod, Ekkart
	\item Mittelbach, Frank
	\item Voss, Herbert
	\item Wölfel, Philipp
	\item Wolter, Steve
\end{itemize}



%^^A -- Versions -------------------------------------------------------------
\cleardoublepage
\section{Versions}
\label{sec:versions}

For a list of versions and the changes within these version, please refer to

\url{https://gitlab.com/ekleinod/changes/blob/master/changelog.md}

Here you too find the implemented but not released changes for the new version.

If you are interested in planned new features, please see

\url{https://gitlab.com/ekleinod/changes/milestones}


%^^A ---- copyright, license
\cleardoublepage
\section{Distribution, Copyright, License}

Copyright 2007-2019 Ekkart Kleinod (\href{mailto:ekleinod@edgesoft.de}{ekleinod@edgesoft.de})

This work may be distributed and/or modified under the conditions of the \hologo{LaTeX} Project Public License, either version~1.3 of this license or any later version.
The latest version of this license is in \url{http://www.latex-project.org/lppl.txt} and version~1.3 or later is part of all distributions of \hologo{LaTeX} version 2005/12/01 or later.

This work has the LPPL maintenance status ``maintained''.
The current maintainer of this work is Ekkart Kleinod.

This work consists of the files

\begin{tabbing}
	mm\=\kill
	\>\texttt{source/latex/changes/changes.drv}\\
	\>\texttt{source/latex/changes/changes.dtx}\\
	\>\texttt{source/latex/changes/changes.ins}\\
	\>\texttt{source/latex/changes/examples.dtx}\\
	\>\texttt{source/latex/changes/README}\\
	\>\texttt{source/latex/changes/userdoc/*.tex}\\

	\>\texttt{scripts/changes/delcmdchanges.bash}
\end{tabbing}


and the derived files

\begin{tabbing}
	mm\=\kill
	\>\texttt{doc/latex/changes/changes.english.pdf}\\
	\>\texttt{doc/latex/changes/changes.english.withcode.pdf}\\
	\>\texttt{doc/latex/changes/changes.ngerman.pdf}\\

	\>\texttt{doc/latex/changes/examples/changes.example.*.tex}\\
	\>\texttt{doc/latex/changes/examples/changes.example.*.pdf}\\

	\>\texttt{tex/latex/changes/changes.sty}
\end{tabbing}


%^^A end of user documentation
